/* OS/2 REXX : The top level configure.cmd; Don't delete this comment. */
call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs
PLATFORM='emx-gcc'
DEBUG='no'
SHARED='yes'
GIF='no'
SM='no'
ZLIB='no'
LIBPNG='no'
I_FLAGS=''
LL_FLAGS=''
l_FLAGS=''
parse arg option1 rest
do while option1\=''
  option=option1
  parse value rest with option1 rest
  select
    when option='-platform' then do
      PLATFORM=option1
      parse value rest with option1 rest
    end /* do */
    when option='-release' then DEBUG='no'
    when option='-debug' then DEBUG='yes'
    when option='-shared' then SHARED='yes'
    when option='-static' then SHARED='no'
    when option='-no-gif' then GIF='no'
    when option='-gif' then GIF='yes'
    when option='-no-sm' then SM='no'
    when option='-sm' then SM='yes'
    when option='-qt-zlib' then ZLIB='yes'
    when option='-system-zlib' then ZLIB='no'
    when option='-qt-libpng' then LIBPNG='yes'
    when option='-system-libpng' then LIBPNG='no'
    when (option='-h'|option='-help'|option='--help') then HELP='yes'
    when option='-v' then VERBOSE='yes'
    when pos('-I',option)=1 then do
      if option='-I' then do
        I_FLAGS=I_FLAGS' -I'option1
        parse value rest with option1 rest
      end /* do */
      else I_FLAGS=I_FLAGS' 'option
    end /* do */
    when pos('-L',option)=1 then do
      if option='-L' then do
        LL_FLAGS=LL_FLAGS' -L'option1
        parse value rest with option1 rest
      end /* do */
      else LL_FLAGS=LL_FLAGS' 'option
    end /* do */
    when pos('-l',option)=1 then do
      if option='-l' then do
        l_FLAGS=l_FLAGS' -l'option1
        parse value rest with option1 rest
      end /* do */
      else l_FLAGS=l_FLAGS' 'option
    end /* do */
  otherwise
    say option1': unknown argument'
    HELP='yes'
    ERROR='yes'
  end  /* select */
end /* do */
if HELP='yes' then do
  parse source 'OS/2' how script
  say 'Usage: 'script' [-debug] [-release] [-gif] [-no-gif] [-sm] [-no-sm] '
  say '        [-qt-zlib] [-system-zlib] [qt-libpng] [-system-libpng] '
  say 'The defaults (*) are usually acceptable.  Here is a short explanation of'
  say 'each option:'
  say ''
  say ' *  -release ........... Compile and link Qt with debugging turned off.'
  say '    -debug ............. Compile and link Qt with debugging turned on.'
  say ''
  say ' *  -shared ............ Create and use a shared Qt library (qt.dll/libqt.so)'
  say '    -static ............ Create and use a static Qt library (qt.a/libqt.a)'
  say ''
  say ' *  -no-gif ............ Do not compile in GIF support. Please see qgif.h.'
  say '    -gif ............... Compile in GIF support. Please see qgif.h.'
  say ''
  say ' *  -no-sm ............. Do not support X Session Management.'
  say '    -sm ................ Support X Session Management, links in -lXSM -lICE.'
  say ''
  say ' *  -qt-zlib ........... Use the zlib bundled with Qt.'
  say '    -system-zlib ....... Use a zlib from the operating system'
  say ''
  say ' *  -qt-libpng ......... Use the libpng bundled with Qt.'
  say '    -system-libpng ..... Use a libpng from the operating system.'
  say ''
  say '    -platform target ... See the PLATFORMS file for a list of supported'
  say '                         operating systems and compilers.'
  say ''
  say '    -Istring ........... Add an explicit include path.'
  say '    -Lstring ........... Add an explicit library path.'
  say '    -lstring ........... Add an explicit library.'
  say ''
  if ERROR='yes' then exit 1
  else exit 0
end /* do */
TARGET=PLATFORM
if SHARED='yes' then TARGET=TARGET'-shared'
else TARGET=TARGET'-static'
if DEBUG='yes' then TARGET=TARGET'-debug'
CONFIG='configs/'TARGET
if SysFileSearch('SYSCONF_CXX',CONFIG,found) then do
  say ''
  say '   The specified platform/compiler not supported: 'TARGET
  say '   Please see the PLATFORMS file for a complete list.'
  say ''
  exit 2
end /* do */
QT_CXX=''
QT_LIBS=''
QT_PNG=''
QT_ZLIB=''
if GIF='yes' then QT_CXX=QT_CXX' -DQT_BUILTIN_GIF_READER'
if SM='yes' then do
  QT_CXX=QT_CXX' -DQT_SM_SUPPORT'
  QT_LIBS=QT_LIBS' -lICE -lSM'
end /* do */
if LIBPNG='yes' then do
  QT_CXX=QT_CXX' -I3rdparty/libpng'
  QT_PNG=' $(PNG_OBJECTS)'
end /* do */
else QT_LIBS=QT_LIBS' -lpng'
if ZLIB='yes' then do
  QT_CXX=QT_CXX' -I3rdparty/zlib'
  QT_ZLIB=' $(ZLIB_OBJECTS)'
end /* do */
else QT_LIBS=QT_LIBS' -lzlib'
QT_LIBS=LL_FLAGS' 'QT_LIBS' 'l_FLAGS
call SysFileDelete '.buildopts'
call lineout '.buildopts','QT_CXXFLAGS_OPT	='QT_CXX' 'I_FLAGS,1
call lineout '.buildopts','QT_CFLAGS_OPT	='I_FLAGS
call lineout '.buildopts','QT_LIBS_OPT	='QT_LIBS
call lineout '.buildopts','QT_PNG_OBJ		='QT_PNG
call lineout '.buildopts','QT_ZLIB_OBJ	='QT_ZLIB
call lineout '.buildopts'
say ''
say 'Build type:    'TARGET
say 'Compile flags: 'QT_CXX' 'I_FLAGS
say 'Link flags:    'QT_LIBS
say 'GIF supports:  'GIF
say ''
say 'Creating makefiles...'
size=stream(CONFIG,'c','query size')
config_contents=charin(CONFIG,,size)
call charout(CONFIG)
size=stream('.buildopts','c','query size')
buildopts=charin('.buildopts',,size)
call charout('.buildopts')
call SysFileTree 'Makefile.in', 'infile', 'FSO'
pwd=translate(directory(),'/','\')
do i=1 to infile.0
  size=stream(infile.i,'c','query size')
  infile_contents=charin(infile.i,,size)
  call charout(infile.i)
  outfile.i=delstr(infile.i,lastpos('.',infile.i))
  call SysFileDelete outfile.i
  call lineout outfile.i,'#############################################################################'
  call lineout outfile.i,'# Automatically generated from 'infile.i
  call lineout outfile.i,'# Build options from 'pwd'/'CONFIG
  call lineout outfile.i,'#############################################################################'
  call lineout outfile.i,''
  call lineout outfile.i,'QTDIR = 'pwd
  call charout outfile.i,config_contents
  call charout outfile.i,buildopts
  call charout outfile.i,infile_contents
  call charout outfile.i
  if VERBOSE='yes' then say '  Created 'outfile.i
end /* do */
if (SHARED='yes'&PLATFORM='emx-gcc') then do
  say 'Creating the module definition file...'
  call SysFileDelete 'src\qtOS2.def'
  do while lines('src\qtOS2.def.in')
    this_line=linein('src\qtOS2.def.in')
    if (GIF='yes'&wordpos(';GIF',this_line)) then
      this_line='  'delword(this_line,1,1)
    if (SM='yes'&wordpos(';SM',this_line)) then
      this_line='  'delword(this_line,1,1)
    call lineout 'src\qtOS2.def',this_line
  end /* do */
  call lineout 'src\qtOS2.def'
  call lineout 'src\qtOS2.def.in'
  if VERBOSE='yes' then say '  Created 'directory()'\src\qtOS2.def'
end /* do */
say ''
say 'Qt is now configured for building. Just run make.'
say 'To reconfigure, run make clean and configure.'
say ''
